Name:           ndppd
Version:        0.2.5
Release:        3%{?dist}
Summary:        Neighbor Discovery Protocol Proxy Daemon

License:        GPLv3
URL:            https://github.com/DanielAdolfsson/ndppd
Source:         https://github.com/DanielAdolfsson/%{name}/archive/%{version}.tar.gz#/%{name}-%{version}.tar.gz
Source1:	ndppd.service
Source2:	ndppd.te
Source3:	ndppd.fc

BuildRequires:  gcc-c++ systemd
Requires: systemd
Requires(post): systemd
Requires(preun): systemd
Requires(postun): systemd

%{?systemd_requires}

%description
ndppd is a daemon that proxies certain IPv6 NDP messages between two or more
interfaces. It currently supports proxying Neighbor Solicitation Messages
and Neighbor Advertisement messages in order to allow IPv6 routing without
relying on Linux "proxy_ndp".

The daemon is partially compliant with (experimental) RFC4389. 


%package selinux
Summary: Targeted SELinux policy module for ndppd
BuildRequires: policycoreutils, checkpolicy, selinux-policy-devel
Requires: policycoreutils, selinux-policy-targeted
Requires: %{name} = %{version}-%{release}
BuildArch: noarch

%description selinux
Targeted SELinux policy module for ndppd.


%prep
%autosetup


%build
%make_build CXXFLAGS="$RPM_OPT_FLAGS" LDFLAGS="$RPM_LD_FLAGS"

# build selinux policy
mkdir selinux
cd selinux
cp -p %{SOURCE2} %{SOURCE3} .
ln -s /usr/share/selinux/devel/Makefile .
make 
cd -

%install
%make_install PREFIX=%{_prefix} DESTDIR=%{buildroot}
mkdir -p %{buildroot}%{_unitdir}
install -pm 644 %{SOURCE1} %{buildroot}%{_unitdir}
mkdir -p %{buildroot}%{_sysconfdir}
install -pm 644 ndppd.conf-dist %{buildroot}%{_sysconfdir}/%{name}.conf

# install selinux modules
mkdir -p %{buildroot}%{_datadir}/selinux/targeted
install -pm 644 selinux/%{name}.pp %{buildroot}%{_datadir}/selinux/targeted
ln -f selinux/%{name}.{te,fc} .  # for doc dir

%pre
getent group ndppd > /dev/null || groupadd -r ndppd
getent passwd ndppd > /dev/null || /usr/sbin/useradd -g ndppd \
        -c "NDP Proxy Daemon" \
        -r -d %{_libexecdir}/ndppd -s /sbin/nologin ndppd
exit 0

%post
%systemd_post %{name}.service

%postun
%systemd_postun_with_restart %{name}.service

%preun
%systemd_preun %{name}.service


%files
%license LICENSE
%doc README* ChangeLog
%{_sbindir}/ndppd
%config(noreplace) %{_sysconfdir}/ndppd.conf
%{_unitdir}/*
%{_mandir}/man1/ndppd.1.gz
%{_mandir}/man5/ndppd.conf.5.gz


%files selinux
%doc selinux/ndppd.te selinux/ndppd.fc 
%{_datadir}/selinux/targeted/*

%post selinux
/usr/sbin/semodule -s targeted -i %{_datadir}/selinux/targeted/%{name}.pp \
        &>/dev/null || :
%{__restorecon} %{_sbindir}/ndppd

%postun selinux
if [ $1 -eq 0 ] ; then
/usr/sbin/semodule -s targeted -r ndppd &> /dev/null || :
fi

%changelog
* Wed Apr 07 2021 Stuart D. Gathman <stuart@gathman.org> 0.2.5-3
- Add selinux policy

* Wed Apr 07 2021 Stuart D. Gathman <stuart@gathman.org> 0.2.5-2
- Fix packaging bugs 

* Fri Apr 02 2021 Stuart D. Gathman <stuart@gathman.org> 0.2.5-1
- Initial package
